BITS 32

; ################################################################
; # Macros permettant de faire un ROR ou un ROL sur une variable #
; ################################################################

%define mac_ror(a,b)	(a>>(b % 32)) | (a<<(32-(b % 32)))  
%define mac_rol(a,b)	(a<<(b % 32)) | (a>>(32-(b % 32))) 

; ######################################################
; # Dfinition de la cl de base.                      #
; # Si aucune cl n'est passe en paramtre, appliquer #
; # une cl par dfaut (ici 'YoLe').                   #
; ######################################################

%ifndef key
	%define key 'YoLe'
%else
	%assign key (key & 0FFFFFFFFh) ; Tronquer la cl reue en 32 bits
%endif

; ####################################
; # Initialiser les variables utiles #
; ####################################

%define base 'Jedi'
%define crypt key

; ####################################################################
; # Macro principale servant  gnrer les macros du code polymorphe #
; ####################################################################

%macro mac 2-4

    ; hachage des cls
    ; ----------------
	%assign crypt 	mac_ror ((crypt^base),(key^base))
	%assign crypt   mac_rol ((key^crypt),(key^crypt))
	
	%assign key  	mac_ror (key,1)
	%assign base 	mac_rol (base,1)	
	
	; Rcupre le numro de la macro  appliquer
	; ------------------------------------------
		
	%assign result ((crypt^(crypt>>8)^(crypt>>16)^(crypt>>24)) % %2)
	
	; Applique la macro correspondant  une instruction
	; asm en fonction du nombre de paramtres.
	; --------------------------------------------------		
	%if %0 = 3
		%1 %+ result %3
		%elif %0 = 4
			%define conca %3 %+ , %+ %4
			%1 %+ result conca
	%else
		%1 %+ result
	%endif
%endmacro

; #######################################################
; # Banque des macros utilises pour le code polymorphe #
; #######################################################

; #######################
; # Macros push reg/imm #
; #######################
%macro push_reg_imm_0		1
	push dword %1
%endmacro

%macro push_reg_imm_1		1
	sub esp,4
	mov dword [esp], %1
%endmacro

%macro push_reg_imm_2		1
	push eax
	push dword %1
	pop dword [esp]
%endmacro
; ----------------------------------------------
	%define push_reg_imm mac push_reg_imm_,3,
; ##############################################

; ###############
; # Macros call #
; ###############

%macro _call_0		1
	call %1
%endmacro

%macro _call_1		1
	push %%suivant
	push dword %1
	retn
%%suivant :
%endmacro

%macro _call_2		1
	push %%suivant
	jmp dword %1	
%%suivant :	
%endmacro
; ----------------------------------------------
	%define _call mac _call_,3,
; ##############################################

; ##########################
; # Dfinition des imports #
; ##########################

extern MessageBoxA
import MessageBoxA user32.dll

extern ExitProcess
import ExitProcess kernel32.dll

; ##########################################
; #                  CODE                  #
; ##########################################

segment code public use32 class=CODE

titre db "Coucou :)",0
texte db "Mon code change d'apparence  chaque compilation et j'aime a :)",0

..start:

	pushad
	push_reg_imm   0x10
	push_reg_imm   titre
	push_reg_imm   texte
	push_reg_imm   0
	_call [MessageBoxA]	
	push_reg_imm   0
	_call [ExitProcess]
	popad	
	retn
	


